import { WrapElementHandle } from "puppeteer";
declare type PJQueryHybrid<TElement = HTMLElement> = PJQuery<TElement> & Promise<PJQuery<TElement>>;
/**
 * Puppeter JQuery interface
 * TODO map and test most of https://api.jquery.com/
 */
export interface PJQuery<TElement = HTMLElement> {
    add(selector?: string): PJQueryHybrid;
    add(html?: string): PJQueryHybrid;
    addClass(className: string): PJQueryHybrid;
    addClass(fnc: (index: number, currentClassName: string) => String): PJQueryHybrid;
    append(content?: string): PJQueryHybrid;
    append(content: (index: number, html: string) => string): PJQueryHybrid;
    addBack(selector?: string): PJQuery;
    addClass(className: String): this;
    attr(attributeName: string): Promise<string>;
    attr(attributeName: string, value: string): this;
    children(selector?: string): PJQueryHybrid;
    closest(selector?: string): PJQueryHybrid;
    css(propertyName: string): Promise<string>;
    css(propertyNames: string[]): Promise<string[]>;
    css(properties: {
        [keys: string]: string | number;
    }): this;
    css(propertyName: string, value: string | number): this;
    css(propertyName: string, value: (index: number, value: string) => string | number): this;
    eq(index: number): PJQueryHybrid;
    find(selector?: string): PJQueryHybrid;
    first(): PJQueryHybrid;
    html(): Promise<string>;
    html(test: string): PJQueryHybrid;
    is(selector_function_selection_elements: String | ((this: TElement, index: number, element: TElement) => boolean)): Promise<boolean>;
    last(): PJQueryHybrid;
    map(callback: (this: TElement, index: number, element: TElement) => any): PJQueryHybrid;
    next(selector?: string): PJQueryHybrid;
    nextAll(selector?: string): PJQueryHybrid;
    nextUntil(selector?: string): PJQueryHybrid;
    not(selector_function_selection: string | ((this: TElement, index: number, element: TElement) => boolean)): PJQueryHybrid;
    offsetParent(): PJQueryHybrid;
    parent(selector?: string): PJQueryHybrid;
    parents(selector?: string): PJQueryHybrid;
    parentsUntil(selector?: string): PJQueryHybrid;
    prev(selector?: string): PJQueryHybrid;
    prevAll(selector?: string): PJQueryHybrid;
    prevUntil(selector?: string, filter?: string): PJQueryHybrid;
    prop(attributeName: string): Promise<string>;
    prop(attributeName: string, value: string): this;
    removeAttr(attributeName: string): this;
    removeProp(attributeName: string): this;
    removeClass(className: String): this;
    siblings(selector?: string): PJQueryHybrid;
    text(): Promise<string>;
    text(test: string): PJQueryHybrid;
    val(): Promise<string>;
    val(test: string): PJQueryHybrid;
    exec(): Promise<WrapElementHandle<any>[]>;
    pojo(): Promise<any[]>;
}
export {};
