import { Page, launch, Browser } from "puppeteer";
import { JQueryAble, IJQueryAble } from './jQueryPlugin';
/**
 * Helper interface to handle Page with JQuery
 */
export interface BrowserEx<T extends Page = PageEx> extends Browser {
    newPage(): Promise<T>;
    pages(): Promise<T[]>;
}
/**
 * Helper interface to handle Page with JQuery
 */
export declare type PageEx<T = IJQueryAble> = Page & T;
/**
 * add JQueryAble Mixin to a Page
 * @param page
 * @returns
 */
export declare function pageExtend<T extends Page = Page>(page: T): T & JQueryAble;
/**
 * launch a puppeter with preloaded jQuery
 * @param options LaunchOptions & BrowserLaunchArgumentOptions & BrowserConnectOptions
 * @returns
 */
export declare function setupJQuery(options?: Parameters<typeof launch>[0]): Promise<BrowserEx<PageEx>>;
